#image: mcr.microsoft.com/dotnet/sdk:5.0

stages:
  - build
  - test
  - publish
  - deploy-dev

variables:
  CUSTOM_MESSAGE: "This is a test ci execution"
  DOTNET_TOOLS_PATH: "$CI_PROJECT_DIR/.dotnet/tools"
  NUGET_PATH: "$CI_PROJECT_DIR/.nuget/"

cache:
    key: $CI_COMMIT_REF_SLUG
    paths:
      - $DOTNET_TOOLS_PATH
      - $NUGET_PATH

before_script:
  - echo "Starting Stage $CI_JOB_STAGE"

after_script:
  - echo "Finishing Stage $CI_JOB_STAGE"

BUILD:
  stage: build
  tags:
    - dotnet5.0
  script:
    - cd myApp
    - dotnet restore ./TrainProject.sln
    - dotnet add package Figgle --package-directory /.nuget/
    - dotnet build ./TrainProject.sln


TEST:
  stage: test
  tags:
    - dotnet5.0
  script:
    - cd myApp
    - mkdir reports
    - dotnet tool install JetBrains.ReSharper.GlobalTools --tool-path /.dotnet/tools
    - /.dotnet/tools/jb inspectcode ./TrainProject.sln -o=reports/report -f=Text -s=WARNING
    - cd ../myApp.Tests
    - mkdir reports
    - dotnet add package coverlet.msbuild --package-directory /.nuget/
    - TESTING_ENVIRONMENT=docker dotnet test -p:CollectCoverage=true -p:CoverletOutputFormat=cobertura -p:CoverletOutput=./reports/ #for coverlet.console
    - dotnet tool install dotnet-reportgenerator-globaltool --tool-path /.dotnet/tools
    - /.dotnet/tools/reportgenerator -reports:./reports/**/coverage.cobertura.xml -targetdir:reports/coveragereport -reporttypes:Html

  coverage: '/\| Total\s*\|\s*([\d\.]+)/' # If codecoverage outputs to console the result

  artifacts:
    expire_in: 7 day
    paths:
      - myApp/reports/report
      - myApp.Tests/reports/coveragereport

PUBLISH:
  stage: publish
  tags:
    - dotnet5.0
  script:
    - cd myApp
    - dotnet restore ./TrainProject.sln -p:Configuration=Release --runtime linux-x64
    - dotnet add package Figgle --package-directory $NUGET_PATH --no-restore
    - dotnet publish ./TrainProject.sln --no-restore -c Release -o ./release/app --runtime linux-x64 --self-contained
    - ls ./release/app

  artifacts:
    expire_in: 7 day
    paths:
      - myApp/release/app


DEPLOY:
  stage: deploy-dev
  tags:
    - ubuntu
  environment:
    name: training
  script:
    - uname -a
    - echo $CUSTOM_MESSAGE
    - cd $CI_PROJECT_DIR/myApp/release/app
    - chmod 777 ./myApp
    - ./myApp
  dependencies:
    - PUBLISH
